<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: main.php 75 2010-04-01 19:40:08Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication(false);

?>
<html>
<head>
	<title><?php echo $lstr['MyViewsPageTitle'];?></title>
	<meta name="ROBOTS" content="NOINDEX, NOFOLLOW">
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<?php do_page_head_links();?>
</head>
<body>

<?php
	$views=get_views(0);
	if(count($views)==0){
?>
<h1><?php echo $lstr['NoViewsDefinedPageHeader'];?></h1>

<p>
<?php echo $lstr['NoViewsDefinedText'];?>
</p>
<?php
	}
?>
	
</body>
</html>
